/********************************************************************************
*                                                                               *
*                        G L   I m a g e    O b j e c t                         *
*                                                                               *
*********************************************************************************
* Copyright (C) 2003 by ABAQUS, Inc.   All Rights Reserved.                     *
*********************************************************************************
* This library is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Library General Public                   *
* License as published by the Free Software Foundation; either                  *
* version 2 of the License, or (at your option) any later version.              *
*                                                                               *
* This library is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             *
* Library General Public License for more details.                              *
*                                                                               *
* You should have received a copy of the GNU Library General Public             *
* License along with this library; if not, write to the Free                    *
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.            *
********************************************************************************/
#ifndef FXGLIMAGE_H
#define FXGLIMAGE_H
// begin local includes
#include <fgl_FGLAPI.h>
#include <FXImage.h>

/// GL Image class
class FGLAPI FXGLImage : public FXImage {
  FXDECLARE(FXGLImage)
  friend class FXDC;
  friend class FXDCWindow;
  friend class FXDrawable;
  friend class FXTopWindow;
#if defined(WIN32)
  friend class FXGLViewer;
#endif
  friend class FXGLContext;

private:
  FXID	   baseXID;
#if defined(WIN32)
  HDC      hdc;
#endif
protected:
  FXGLImage();
private:
  FXGLImage(const FXGLImage&);
  FXGLImage &operator=(const FXGLImage&);
public:

  /// Create an image
  FXGLImage(FXApp* a,const void *pix=NULL,FXuint opts=0,FXint w=1,FXint h=1);

  /// Create image resource
  virtual void create();

  /// Detach image resource
  virtual void detach();
  
  /// Destroy image resource
  virtual void destroy();
  
  /// Restore client-side pixel buffer from image
  virtual void restore();

  /// Resize pixmap to the specified width and height  
  virtual void resize(FXint w,FXint h);

  /// Destructor
  virtual ~FXGLImage();
  };
  
    
#endif
