#ifndef atr_Allocator_h
#define atr_Allocator_h

class atr_Allocator
{
public:
    struct Block
    {
        Block* next;
        int high;
        int total;

        inline Block(Block*,int);
        inline int* GetArray();
    };

    atr_Allocator(int chunkSize, int maxExtra=0, int blockSize=0);
    ~atr_Allocator();

    void* Allocate(int extraChunks=0);
    bool  Extend(void* addr, int oldExtra, int newExtra);
    void  Release(void* addr, int extraChunks=0);

private:

    Block* first;
    int chunkSize;
    int maxExtra;
    int blockLimit;
};

#endif // atr_Allocator_h
