/* -*- mode: c++ -*- */
///////////////////////////////////////////////////////////////////////////////
//
// File Name: omi_alloca.h
//
// Description: The alloca function allocates memory off the stack.
//              It is much faster than 'malloc' or 'new' but is not
//              as portable.
//
// NOTICE:    	You never want to release memory allocated with 'alloca'
//  	    	but since it may not be available you need to use the
//  	    	'free_alloca' macro to TRY to release the memory.  On
//  	    	systems where 'alloca' exists this will be a NOOP.  On
//  	    	systems where 'alloca' does not exist, failure to call
//  	    	'free_alloca' will produce a memory leak!
//
//
//
#ifndef omi_alloca_h
#define omi_alloca_h

//#if 1

#if defined(HKS_NT)
#include <malloc.h>
#define alloca  _alloca
#elif defined(RS6000)
#include <stdlib.h>
#else
#include <alloca.h>
#endif
#define free_alloca(PTR)    // NOOP

//#else // Someone not have this?

//#define alloca	    	    malloc
//#define free_alloca(PTR)    free(PTR)

//#endif

#endif  // omi_alloca_h
